// Soroban.app \[XR[h  by kako

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import "UIKit/UIView.h"
#import "UIKit/UIImageView.h"
#import <UIKit/UITextView.h>

extern CGPoint GSEventGetLocationInWindow(struct __GSEvent*);
extern CGPoint GSEventGetInnerMostPathPosition(struct __GSEvent*);
extern CGPoint GSEventGetOuterMostPathPosition(struct __GSEvent*);

#define ROWS 6
#define OFS  6
#define MOVE  35
#define MOVE2 30

#define ABS(a)  (((a) < 0) ? -(a) : (a))


//////////////////////////////////////////////////////////////////////////////
// interface  definition
//////////////////////////////////////////////////////////////////////////////

@interface MainView : UIView
{
	int px1,py1, px2,py2;
	int ax,ay,az, ax_old,ay_old,az_old;
	UIImage *Image0,*Image1,*Image2,*Image3;
	UIImageView *pictView_BG,*pictViewH;
	UIImageView *pictView[ROWS];
	UIImageView *tamaView[ROWS][5];
	UIImageView *touchXY_View1,*touchXY_View2;
	CGRect rect_pict1,rect_pict2;
	float pos[ROWS][5];
	NSTimer *timer;
}
-(id)initWithFrame:(CGRect)rect;
-(void) tama_set:(float)f;
-(void) tama_random:(float)f;
-(void)interval_function;
-(void)acceleratedInX:(float)xx Y:(float)yy Z:(float)zz;
-(void)mouseUp:(struct __GSEvent*)e;
-(void)mouseDown:(struct __GSEvent*)e;
-(void)mouseDragged:(struct __GSEvent*)e;
-(void)gestureStarted:(struct __GSEvent *)e;
-(void)gestureEnded:(struct __GSEvent *)e;
-(void)gestureChanged:(struct __GSEvent *)e;
@end


//////////////////////////////////////////////////////////////////////////////
//  implementation
//////////////////////////////////////////////////////////////////////////////

@implementation MainView
-(id)initWithFrame:(CGRect)rect
{
	int i,j;
	srand(time(0)); // ̏
	for (j=0;j<ROWS;j++) {
		for (i=0;i<4;i++) { pos[j][i]=0.0; }
		pos[j][4]=1.0;
	}
	px1= -1; py1= -1; px2= -1; py2= -1;
	
	// ViewIuWFNg̏
	self = [super initWithFrame:rect];
	
	// wi\
	pictView_BG = [[UIImageView alloc] initWithFrame: rect];
	[pictView_BG setEnabled:NO];
	[self addSubview: pictView_BG];
	[pictView_BG setImage: [UIImage imageNamed:@"Default.png"]];
	
	// c_\
	Image1 = [UIImage imageNamed:@"bar-v.png"];
	for (j=0;j<ROWS;j++) {
		rect_pict1.origin.x=0;  rect_pict1.origin.y=OFS+34 + 80*j;
		rect_pict1.size = [Image1 size];
		pictView[j] = [[UIImageView alloc] initWithFrame:rect_pict1];
		[pictView[j] setImage: Image1];  [pictView[j] setEnabled:NO];  [self addSubview: pictView[j]];
	}
	
	// _\
	Image2 = [UIImage imageNamed:@"bar-h.png"];
	rect_pict1.origin.x=320-80-20;  rect_pict1.origin.y=0;
	rect_pict1.size = [Image2 size];
	pictViewH = [[UIImageView alloc] initWithFrame:rect_pict1];
	[pictViewH setImage: Image2];  [pictViewH setEnabled:NO];  [self addSubview: pictViewH];
	
	// \
	Image3 = [UIImage imageNamed:@"tama.png"];
	for (j=0;j<ROWS;j++) {
		for (i=0;i<5;i++) {
			rect_pict1.origin.y= -100; rect_pict1.origin.y=OFS+34+5-35+80*j;
			rect_pict1.size = [Image3 size];
			tamaView[j][i] = [[UIImageView alloc] initWithFrame:rect_pict1];
			[tamaView[j][i] setImage: Image3];  [tamaView[j][i] setEnabled:NO];
			[self addSubview: tamaView[j][i]];
		}
	}
	
	// ^b`Wx2̃CWP[^[̕\
	Image0 = [UIImage imageNamed:@"cursor.png"];
	rect_pict2.origin.x= -100;  rect_pict2.origin.y= 0; rect_pict2.size = [Image0 size];
	touchXY_View1 = [[UIImageView alloc] initWithFrame:rect_pict2];
	[touchXY_View1 setImage: Image0]; [touchXY_View1 setEnabled:NO];
	[self addSubview: touchXY_View1];
	touchXY_View2 = [[UIImageView alloc] initWithFrame:rect_pict2];
	[touchXY_View2 setImage: Image0]; [touchXY_View2 setEnabled:NO];
	[self addSubview: touchXY_View2];
	
	// WFX`[L (MainViewȊOsenEnabled:NOMainViewCxg 炵)
	[self setGestureDelegate: self]; [self setEnabledGestures: YES];
	
	// ^C}[N
	timer = [NSTimer scheduledTimerWithTimeInterval:.05
	                 target:self selector:@selector(interval_function) userInfo:nil repeats:YES ];
	return self;
}

-(void) tama_set:(float)f
{
	int i,j;
	for (j=0;j<ROWS;j++) {
		for (i=0;i<5;i++) { pos[j][i]=f; }
	}
}

-(void) tama_random:(float)f
{
	int j;
	if (f<0.4) {
		for (j=0;j<ROWS;j++) {
			pos[j][0]= 0.2 + 0.4 * ((float)(rand() % 100)/100 ) -0.2;
			pos[j][1]= pos[j][0] + 0.15 * ((float)(rand() % 100)/100 );
			pos[j][2]= pos[j][1] + 0.15 * ((float)(rand() % 100)/100 );
			pos[j][3]= pos[j][2] + 0.15 * ((float)(rand() % 100)/100 );
			pos[j][4]= 0.25 + 0.5 * ((float)(rand() % 100)/100 ) -0.25;
		}
	} else if (f>0.6) {
		for (j=0;j<ROWS;j++) {
			pos[j][3]= 0.8 + 0.4 * ((float)(rand() % 100)/100 ) -0.2;
			pos[j][2]= pos[j][3] - 0.15 * ((float)(rand() % 100)/100 );
			pos[j][1]= pos[j][2] - 0.15 * ((float)(rand() % 100)/100 );
			pos[j][0]= pos[j][1] - 0.15 * ((float)(rand() % 100)/100 );
			pos[j][4]= 0.75 + 0.5 * ((float)(rand() % 100)/100 ) -0.25;
		}
	} else {
		for (j=0;j<ROWS;j++) {
			pos[j][0]= 0.25 * ((float)(rand() % 100)/100 );
			pos[j][1]= pos[j][0] + 0.25 * ((float)(rand() % 100)/100 );
			pos[j][2]= pos[j][1] + 0.25 * ((float)(rand() % 100)/100 );
			pos[j][3]= pos[j][2] + 0.25 * ((float)(rand() % 100)/100 );
			pos[j][4]= 1.0 * ((float)(rand() % 100)/100 );
		}
	}
}


-(void)interval_function	// ^C}[
{
	int n,i,j,flag,ti,tj;
	float x,y,tx,ty,adj1,adj2;
	static int ti_old1,tj_old1;
	static int ti_old2,tj_old2;
	CGPoint pos1,pos2,pos3;
	
	// ^b`WɃCWP[^[𓮂
	pos1=CGPointMake(-100,-100); pos2=CGPointMake(-100,-100);
	if (px1 != -1) { pos1=CGPointMake(px1,py1); }
	if (px2 != -1) { pos2=CGPointMake(px2,py2); }
	[touchXY_View1 setPosition:pos1]; [touchXY_View2 setPosition:pos2];
	
	// ^b`W`FbNāÄʒuω
	flag=0;
	for (n=0;n<2;n++) {
		if (n==0) { tx=px1; ty=py1; }
		if (n==1) { tx=px2; ty=py2; }
		for (j=0;j<ROWS;j++) {
			for (i=0;i<5;i++) {
				if (i<4) { x = 45.5*i +25 + pos[j][i]*MOVE;  }
				else     { x = 320    -55 + pos[j][i]*MOVE2; }
				y = OFS + 80*j + 39;
				adj1=0; adj2=0;
				if (i==4) { adj1=18; }
				if (i==3) { adj2=5; }
				if ( ( (tx-x) > -23-adj1 )&&( (tx-x) < 23+adj2 )&&( ABS(ty-y)<28 ) ) {
					if ((i!=ti_old1)||(j!=tj_old1)) {
						if ((i!=ti_old2)||(j!=tj_old2)) {
							if ((tx-x)>0) { flag=1; } else { flag= -1; }
							ti=i; tj=j; break;
						}
					}
				}
			}
			if (flag !=0) { break; }
		}
		if (flag==1) {
			pos[tj][ti]=0.0;
			if (ti==3) { pos[tj][2]=0.0; pos[tj][1]=0.0; pos[tj][0]=0.0; }
			if (ti==2) { pos[tj][1]=0.0; pos[tj][0]=0.0; }
			if (ti==1) { pos[tj][0]=0.0; }
		} else if (flag== -1) {
			pos[tj][ti]=1.0;
			if (ti==0) { pos[tj][1]=1.0; pos[tj][2]=1.0; pos[tj][3]=1.0; }
			if (ti==1) { pos[tj][2]=1.0; pos[tj][3]=1.0; }
			if (ti==2) { pos[tj][3]=1.0; }
		}
		if (flag!=0) {
			if (n==0) { ti_old1=ti; tj_old1=tj; }
			if (n==1) { ti_old2=ti; tj_old2=tj; }
		} else {
			if (px1 == -1) {
				ti_old1= -1; tj_old2= -1;
			}
		}
	}
	
	// xZT[̃`FbN, {̂XꍇƐUꍇ̏
	if ( (ax > 650)&&(ax < 1100)&&(ax_old > 650) ) {
		[self tama_set: 0.0];
	} else if ( (ax < -550)&&(ax > -1100)&&(ax_old < -550) ) {
		[self tama_set: 1.0];
	} else if ( (ax_old-ax > 1000)||(ax_old-ax < -1000 )) {
		if      (ax >  700) { [self tama_random: 0.0]; }
		else if (ax < -700) { [self tama_random: 1.0]; }
		else                { [self tama_random: 0.5]; }
	}
	
	// ̕\ʒu𓮂
	for (j=0;j<ROWS;j++) {
		for (i=0;i<5;i++) {
			if (i<4) { pos3.x = 45.5*i +25 + pos[j][i]*MOVE;  }
			else     { pos3.x = 320    -55 + pos[j][i]*MOVE2; }
			pos3.y = OFS + 80*j + 39;
			[tamaView[j][i] setPosition:pos3];
		}
	}
}

-(void)acceleratedInX:(float)xx Y:(float)yy Z:(float)zz
{
	ax_old=ax; ay_old=ay; az_old=az;   ax=xx*2500; ay=yy*2500; az=zz*2500;
}

-(void)mouseUp:(struct __GSEvent*)e
{
	px1= -1; py1= -1;  px2= -1; py2= -1;
}
-(void)mouseDown: (struct __GSEvent*)e
{
	CGPoint p0 = GSEventGetLocationInWindow(e);	// 1_ڂ̃^bv
	px1=p0.x; py1=p0.y; px2= -1; py2= -1;
}

-(void)mouseDragged:(struct __GSEvent*)e
{
	CGPoint p0 = GSEventGetLocationInWindow(e);	// 1_ڂ^bvhbOꂽ
	px1=p0.x; py1=p0.y; px2= -1; py2= -1;
}

-(void)gestureEnded:(struct __GSEvent *)e
{
	CGPoint p0 = GSEventGetLocationInWindow(e);	// 1_ڂ^bvhbOꂽ
	px1=p0.x; py1=p0.y; px2= -1; py2= -1;
}

-(void)gestureStarted:(struct __GSEvent *)e
{	
	CGPoint p1 = GSEventGetInnerMostPathPosition(e); // 2_ڂ̃^bv
	CGPoint p2 = GSEventGetOuterMostPathPosition(e);
	px1=p1.x; py1=p1.y; px2=p2.x; py2=p2.y;
}

-(void)gestureChanged:(struct __GSEvent *)e
{
	CGPoint p1 = GSEventGetInnerMostPathPosition(e); // 2_ڂ^bvhbOꂽ
	CGPoint p2 = GSEventGetOuterMostPathPosition(e);
	px1=p1.x; py1=p1.y; px2=p2.x; py2=p2.y;
}
@end



//////////////////////////////////////////////////////////////////////////////
//  UIApplication interface and implementation
//////////////////////////////////////////////////////////////////////////////
@interface MyApplication : UIApplication
{
	MainView *mainView;
}
-(void) applicationDidFinishLaunching: (id) unused;
@end
@implementation MyApplication
-(void) applicationDidFinishLaunching:(id)unused
{
	[UIHardware _setStatusBarHeight:0.0f]; [self setStatusBarMode:2 duration:0.0f];// Hide StatusBar
	CGRect rect = [UIHardware fullScreenApplicationContentRect]; rect.origin.x = rect.origin.y = 0;
	UIWindow *window = [[UIWindow alloc] initWithContentRect:rect];
	[window orderFront: self]; [window makeKey: self]; [window _setHidden: NO];
	mainView = [[MainView alloc] initWithFrame: rect];
	[window setContentView:mainView]; [window setNeedsDisplay];
}
-(void)acceleratedInX:(float)x Y:(float)y Z:(float)z
{
	[mainView acceleratedInX:x Y:y Z:z];
}
@end


//////////////////////////////////////////////////////////////////////////////
//  start
//////////////////////////////////////////////////////////////////////////////
int main(int argc, char **argv)
{
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	int r=UIApplicationMain(argc, argv, [MyApplication class]);
	[pool release];
	return r;
}

